---
title: RTCRemoteOutboundRtpStreamStats.localId
slug: Web/API/RTCRemoteOutboundRtpStreamStats/localId
tags:
  - API
  - Media
  - Outbound
  - Property
  - RTCRemoteOutboundRtpStreamStats
  - RTP
  - Reference
  - Remote
  - Statistics
  - Stats
  - Streams
  - WebRTC
  - WebRTC API
  - WebRTC Device API
  - id
  - localId
---
<p>{{APIRef("WebRTC")}}</p>

<p><span class="seoSummary">The {{domxref("RTCRemoteOutboundRtpStreamStats")}} dictionary's  <code><strong>localId</strong></code> property is a string which can be used to identify the {{domxref("RTCInboundRtpStreamStats")}} object whose {{domxref("RTCInboundRtpStreamStats.remoteId", "remoteId")}} matches this value. </span>Together, these two objects provide statistics about the inbound and outbound sides of the same synchronization source (SSRC).</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">let <em>localId</em> = <em>rtcRemoteOutboundRtpStreamStats</em>.localId;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} which can be compared to the value of an {{domxref("RTCInboundRtpStreamStats")}} object's {{domxref("RTCInboundRtpStreamStats.remoteId", "remoteId")}} property to see if the two represent statistics for each of the two sides of the same set of data received by the local peer.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>You can think of the local and remote views of the same RTP stream as pairs, each of which has a reference back to the other one. Thus, if an {{domxref("RTCStatsReport")}} includes an <code>remote-outbound-rtp</code> statistics object (of type <code>RTCRemoteOutboundRtpStreamstats</code>), it should also have a corresponding <code>inbound-rtp</code> object. Both of these provide information about the same batch of packets being transmitted from the remote peer to the local device. The difference is that <code>remote-outbound-rtp</code> describes statistics about the transmission(s)  from the perspective of the remote peer, while <code>inbound-rtp</code> offers statistics about the incoming data from the local peer's perspective.</p>

<p>You can {{anch("Try it and fork it", "examine, try out, and experiment")}} with this example on Glitch.</p>

<h2 id="Example">Example</h2>

<p>In this example, we have a pair of functions: the first, <code>networkTestStart()</code>, captures an initial report, and the second, <code>networkTestStop()</code>, captures a second report, then uses the two reports to output some information about the network conditions... XXX ...</p>

<h3 id="networkTestStart">networkTestStart()</h3>

<p>This function calls the {{domxref("RTCPeerConnection")}} method {{domxref("RTCPeerConnection.getStats", "getStats()")}} to request an {{domxref("RTCStatsReport")}} and store it in the variable <code>startReport</code>.</p>

<pre class="brush: js notranslate">let startReport;

async function networkTestStart(pc) {
  if (pc) {
    startReport = await pc.getStats();
  }
}</pre>

<p>Given an {{domxref("RTCPeerConnection")}}, <code>pc</code>, this calls its {{domxref("RTCPeerConnection.getStats", "getStats()")}} method to obtain a statistics report object, which it stores in <code>startReport</code> for use once the end-of-test data has been collected by <code>networkTestStop()</code>.</p>

<h3 id="networkTestStop">networkTestStop()</h3>

<p>The <code>networkTestStop()</code> function obtains a second report, <code>endReport</code>, then uses the two reports together to determine several... XXX ...</p>

<h4 id="Finding_paired_statistics">Finding paired statistics</h4>

<p>Each statistics record of {{domxref("RTCStats.type", "type")}} <code>remote-outbound-rtp</code> (describing a remote peer's statistics about sending data to the local peer) has a corresponding record of type <code>inbound-rtp</code> which describes the local peer's perspective on the same data being moved between the two peers. Let's create a utility function to help us look up the value of a key in the paired statistics object.</p>

<p>The <code>findReportEntry()</code> function shown below examines an {{domxref("RTCStatsReport")}}, returning the {{domxref("RTCStats")}}-based statistics record which contains the specified <code>key</code> — <em>and</em> for which the key has the specified <code>value</code>. If no match is found (or the statistics report has no record corresponding to the statistics category indicated by <code>key</code>.</p>

<pre class="brush: js notranslate">function findReportEntry(report, key, value) {
  for (const stats of report.values()) {
    if (stats[key] === value) {
      return stats;
    }
  }
  return null;
}</pre>

<p>Since the <code>RTCStatsReport</code> is a JavaScript <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Map">Map</a></code>, we can iterate over the map's <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Map/values">values()</a></code> to examine each of the <code>RTCStats</code>-based statistics records in the report until we find one that has the <code>key</code> property with the specified <code>value</code>. When a match is found, the statistics object is returned.</p>

<p>If no match is found, the function returns <code>null</code>.</p>

<h4 id="The_main_networkTestStop_function">The main networkTestStop() function</h4>

<p>Now let's look at the <code>networkTestStop()</code> function itself. It takes as input the {{domxref("RTCPeerConnection")}} being tested, calls <code>getStats()</code> to get a new <code>RTCStatsReport</code> with current statistics, then computes the results it's looking for, outputting those results as appropriate to the user by appending appropriate HTML to the contents of the {{HTMLElement("div")}} element whose class is <code>stats-box</code>.</p>

<pre class="brush: js notranslate">async function networkTestStop(pc) {
  if (pc) {
    let statsBox = document.querySelector(".stats-box");
    let endReport = await pc.getStats();

    for (let endRemoteOutbound of endReport.values()) {
      if (endRemoteOutbound.type === "remote-outbound-rtp") {
        let startRemoteOutbound = startReport.get(endRemoteOutbound.id);

        if (startRemoteOutbound) {
          let startInboundStats = findReportEntry(startReport, "remoteId", startRemoteOutbound.id);
          let endInboundStats = findReportEntry(endReport, "remoteId", endRemoteOutbound.id);

          let elapsedTime = (endRemoteOutbound.timestamp - startRemoteOutbound.timestamp) / 1000;    /* in seconds */
          let packetsSent = endRemoteOutbound.packetsSent - startRemoteOutbound.packetsSent;
          let bytesSent = endRemoteOutbound.bytesSent - startRemoteOutbound.bytesSent;
          let framesDecoded = endInboundStats.framesDecoded - startInboundStats.framesDecoded;
          let frameRate = framesDecoded / elapsedTime;

          let timeString = "";
          if (!isNaN(elapsedTime)) {
            timeString = ` representing ${elapsedTime}s`;
          }

          let frameString = "";
          if (!isNaN(framesDecoded)) {
            frameString = `Decoded ${framesDecoded} frames for a frame rate of ${frameRate.toFixed(2)} FPS.&lt;br&gt;`;
          }

          let logEntry = `&lt;div class="stats-entry"&gt;&lt;h2&gt;Report ID: ${endRemoteOutbound.id}&lt;/h2&gt;` +
                         `Remote peer sent ${packetsSent} packets ${timeString}.&lt;br&gt;` +
                         `${frameString}` +
                         `Data size: ${bytesSent} bytes.&lt;/div&gt;`;
          statsBox.innerHTML += logEntry;
        } else {
          statsBox.innerHTML += `&lt;div class="stats-error"&gt;Unable to find initial statistics for ID ${endRemoteOutbound.id}.&lt;/div&gt;`
        }
      }

      statsBox.scrollTo(0, statsBox.scrollHeight);
    }
  }
}</pre>

<p>Here's what's going on in the <code>networkTestStop()</code> function: after calling the {{domxref("RTCPeerConnection")}} method {{domxref("RTCPeerConnection.getStats", "getStats()")}} to get the latest statistics report for the connection and storing it in <code>endReport</code>,  This is an {{domxref("RTCStatsReport")}} object, which maps strings taken from the {{domxref("RTCStatsType")}} enumerated type to objects of the corresponding {{domxref("RTCStats")}}-based type.</p>

<p>Now we can begin to process the results, starting with the ending statistics found in <code>endReport</code>. In this case, we're looking for statistics records whose <code>type</code> is <code>remote-outbound-rtp</code>, so we iterate over the entries in the statistics report until we find an entry of that type. This object is, specifically, of type {{domxref("RTCRemoteOutboundRtpStreamStats")}}, and it provides statistics giving details about the state of things <em>from the perspective of the remote peer</em>. This statistics record is stored in <code>endRemoteOutbound</code>.</p>

<p>Once the ending <code>remote-outbound-rtp</code> record is found, we use its {{domxref("RTCStats.id", "id")}} property to get its ID. WIth that in hand, we can look up the <code>remote-outbound-rtp</code> record in the starting statistics record (<code>startReport</code>), which we store into <code>startRemoteOutbound</code>.</p>

<p>Now we obtain the <code>inbound-rtp</code> statistics that correspond to these two <code>remote-outbound-rtp</code> records by finding the <code>remoteId</code> property within them whose value is the ID of the <code>remote-outbound-rtp</code> record. We use the <code>findReportEntry()</code> function described in the previous section for that, storing the located <code>inbound-rtp</code> records in <code>startInboundStats</code> and <code>endInboundStats</code>.</p>

<p>Now we have all the raw statistics needed to calculate the information we want to display, so we do so:</p>

<ul>
 <li>We calculate the amount of time—<code>elapsedTime</code>—that elapsed between the two reports being sent by subtracting the {{domxref("RTCStats.timestamp", "timestamp")}} <code>startReport</code> from that of <code>endReport</code>. We then divide by 1000 to convert the result from milliseconds to seconds.</li>
 <li>We compute the number of packets sent during this interval—<code>packetsSent</code>—by subtracting the two reports' values for the {{domxref("RTCSentRtpStreamStats.packetsSent", "packetsSent")}} property.</li>
 <li>Similarly, the number of bytes sent during this interval—<code>bytesSent</code>—is calculated by subtracting the starting statistics object's {{domxref("RTCSentRtpStreamStats.bytesSent", "bytesSent")}} property from that of the ending statistics.</li>
 <li>The number of frames decoded during this interval—<code>framesDecoded</code>—is determined by subtracting <code>startRecord</code>'s {{domxref("RTCInboundRtpStreamStats.framesDecoded", "framesDecoded")}} from <code>endRecord.framesDecoded</code>.</li>
 <li>Finally, the frame rate over the elapsed time span is calculated by dividing <code>framesDecoded</code> by <code>elapsedTime</code>.</li>
</ul>

<p>The remainder of the <code>networkTestStop()</code> function constructs the HTML used to display the output of the collected and computed results to the user, then append it to the element <code>statsBox</code>, which we're using to show the status updates to the user.</p>

<p>The output log, given the styles used by the example, looks like this:</p>

<p><img alt="A screenshot of the example showing logged statistics taken from paired remote-outbound-rtp and inbound-rtp statistics records" src="https://mdn.mozillademos.org/files/17306/rtc-log-screenshot.png" style="height: 410px; width: 650px;"></p>

<p>In the screenshot, we see a heading followed by the scrollable {{HTMLElement("div")}} we refer to as <code>statsBox</code>. The box contains a number of log entries, the last handful of which are visible. Each one represents approximately one second of time (since that's much time we're waiting between calling <code>networkTestStart()</code> and <code>networkTestStop()</code>).</p>

<h3 id="Try_it_and_fork_it">Try it and fork it</h3>

<p>This example is <a href="https://websocket-webrtc-chat-with-stats.glitch.me">available on Glitch for you to try out</a>, examine, or remix.  You can also <a href="https://33030790-3517-4d21-9b93-511347fa1ebd@api.glitch.com/git/websocket-webrtc-chat-with-stats">access it directly</a> using Glitch's Git server.</p>

<div class="column-container">
<div class="column-2"><a href="https://glitch.com/edit/?utm_content=project_websocket-webrtc-chat-with-stats&amp;utm_source=remix_this&amp;utm_medium=button&amp;utm_campaign=glitchButton#!/remix/websocket-webrtc-chat-with-stats"><img alt="Remix It" src="https://cdn.glitch.com/2bdfb3f8-05ef-4035-a06e-2043962a3a13%2Fremix%402x.png?1513093958726" style="height: 20px;"> </a></div>

<div class="column-2"><a href="https://glitch.com/edit/?utm_content=project_websocket-webrtc-chat-with-stats&amp;utm_source=view_source&amp;utm_medium=button&amp;utm_campaign=glitchButton#!/websocket-webrtc-chat-with-stats"><img alt="View Source" src="https://cdn.glitch.com/2bdfb3f8-05ef-4035-a06e-2043962a3a13%2Fview-source%402x.png?1513093958802" style="height: 20px;"></a></div>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebRTC Statistics Identifiers', '#dom-rtcremoteoutboundrtpstreamstats-localid', 'RTCRemoteOutboundRtpStreamStats.localId')}}</td>
   <td>{{Spec2('WebRTC Statistics Identifiers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCRemoteOutboundRtpStreamStats.localId")}}</p>
